unit ldn137_u1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;

type

  { Tldn137_f1 }

  Tldn137_f1 = class(TForm)
    bQuit: TButton;
    buConvert: TButton;
    eStringOfDecimalToConvert: TEdit;
    laTxtCaution: TLabel;
    laTxtResultString: TLabel;
    laResultString: TLabel;
    laInputStringOfDecimal: TLabel;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    procedure bQuitClick(Sender: TObject);
    procedure buConvertClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    ssTmp:shortstring;
    function ssOLDConvertToHex(ssToConvert:shortstring;
        bMaxHexChars:byte):shortstring;
    function ssConvertToChars(i32Convert:uint32;
        bbCharsToUse,bBase:byte):shortstring;
  public

  end;

var
  ldn137_f1: Tldn137_f1;

const vers='08 Jun 2023, 16:10';
  //started 08 Jun 2023, for ar202 (Arduino)
  //https://wywtk.com/ardsrv/ardsrv_23518_2t2h_door.htm
  kAppName='LDN137';

  kCharsToUse='0123456789abcdefghjkmnpqrtvwxyz';
  kbCharsToUseAllowed=6;//If you want to convert to equivalent strings
     //which are longer than this, the code will need tweaking

(*Grand finale!

  See LDN138... yes, sorry, LOWER number for "lower" tutorial!...
  for the first part of this... the part where the basic outline
  was developed.

  In this, I have replaced the use of the built in HexStr function
  with a "by hand" alternative. (I was developing an algorithm to use
  in an Arduino.)

  ---
  function ssOLDConvertToHex is NOT USED in this... it is what we
  used in the previous tutorial, the one that introduced this,
  got us started to towards this, our final answer.

  ---

  I've used a TRadio group just to provide an easy-to-use way
  for the user to indicate how many hex characters to allocate, i.e
  at what stage the hex result will roll over, if you give the function
  a "too big" number.

  They aren't the most intuitive component for the programmer!

  Know.... you "add buttons" saying 1,2,3... to the RadioGroup
    by adding lines with 1, 2, 3 on them to the Items property.
  I then changed the Columns property to 8,
  and the ColumnLayout property to clVerticalThenHorizontal

  To have my *3rd* button selected when the program launches, I set
    ItemIndex property to *2*
  ---
  While the program is running, I can see which radio button is
  selected with bSelected:=RadioGroup1.ItemIndex. That returns
  the INDEX of course. To get 3 into bSelected if my buttons
  are labeled 1,2,3... I need bSelected:=RadioGroup1.ItemIndex+1,
  don't I? (Not hard. Not arcane. but a great "gotcha"!)

  ---
  My use of the "Convert it" button is clumsy. Sorry. There ARE
  better ways, ways that make the conversion happen when you change
  what's in the edit box... but they are a story for another day!

*)
implementation

{$R *.lfm}

{ Tldn137_f1 }

procedure Tldn137_f1.FormCreate(Sender: TObject);
begin
  application.title:=kAppName;
  {main form.}caption:=kAppName+' vers: '+vers;
  eStringOfDecimalToConvert.text:='0000';
  RadioGroup1.caption:='How many characters should result have?';
  laInputStringOfDecimal.caption:='< Enter decimal to convert';
  eStringOfDecimalToConvert.text:='255';
  laResultString.caption:='';
  RadioGroup1.caption:='Number of characters to use in result:';
end;

procedure Tldn137_f1.bQuitClick(Sender: TObject);
begin
  close;//get in habit of using Close. Better than App... terminate.
  //(Important when you start using ini files updated during prgm run)
end;

procedure Tldn137_f1.buConvertClick(Sender: TObject);
var
  i32ToConvertFrmDecimal:uint32;
  //UInt32 - Range: (0 .. 4294967295)
begin
  //in due course, fill i32ToConvert... from eStringOfDecimalToConvert.text
  //For now...
  i32ToConvertFrmDecimal:=4369+16;
  //ssTmp:=ssConvertToChars(i32ToConvertFrmDecimal,
    //                                  RadioGroup1.ItemIndex+1,16);
  ssTmp:=ssConvertToChars(i32ToConvertFrmDecimal,
                                      2{RadioGroup1.ItemIndex+1},16);
  laResultString.caption:='h/c '+inttostr(i32ToConvertFrmDecimal)+'='+ssTmp;
end;

function Tldn137_f1.ssConvertToChars(i32Convert:uint32;bbCharsToUse,
           bBase:byte):shortstring;
//UInt32 - Range: (0 .. 4294967295)
var i16MaskValue:uint16;
    bCountForThisChar:byte;
    ssResult:shortstring;
begin
  if bbCharsToUse>=kbCharsToUseAllowed then begin
    ssResult:='bCharsToUse too big';
    end// no ; here
   else begin //1
     i16MaskValue:=$100;// this will need to be made more clever! Derive
       //from bbCharsToUse and bBase
     i32Convert:=i32Convert mod i16MaskValue;//Prelim "chop away" of
       //"size" beyond what can be shown in bbCharsToUse
     ssResult:='';

     //--
     bCountForThisChar:=0;
     while i32Convert>=i16MaskValue do begin
       inc(bCountForThisChar);
       i32Convert:=i32Convert-i16MaskValue;
       end;//while
     ssResult:=ssResult+copy(kCharsToUse,bCountForThisChar+1,1);
     i16MaskValue:=$10;//i16MaskValue mod 16;

     //--
     bCountForThisChar:=0;
     while i32Convert>=i16MaskValue do begin
       inc(bCountForThisChar);
       i32Convert:=i32Convert-i16MaskValue;
       end;//while
     ssResult:=ssResult+copy(kCharsToUse,bCountForThisChar+1,1);
     i16MaskValue:=i16MaskValue mod 16;

     (*//--
     bCountForThisChar:=0;
     while i32Convert>=i16MaskValue do begin
       inc(bCountForThisChar);
       i32Convert:=i32Convert-i16MaskValue;
       end;//while
     ssResult:=ssResult+inttostr(bCountForThisChar);
     i16MaskValue:=i16MaskValue mod 16;
       *)
     //--and finally, for the last character

     ssResult:=ssResult+copy(kCharsToUse,i32Convert+1,1);

    end;//of "else //1"
  result:=ssResult;
end;//ssConvertToChars;

function Tldn137_f1.ssOLDConvertToHex(ssToConvert:shortstring;bMaxHexChars:byte):shortstring;
(*Yes! Lazarus has a function for this!...
  https://www.freepascal.org/docs-html/rtl/system/hexstr.html
  ... but I needed an ALGORITM, to "translate" to Arduino code.
  If you want hex from decimal for a Lazarus program, by all
  means use hexstr. It is demonstrated in my LTN138.
  At 8 Jun 23, the example given in the Lazarus documentation
  chose a very odd value for "Value" in...
  Writeln (HexStr(Value,I));
  A value of 15 ($F), or ($ffff) might have made more sense.
  *)
begin
  result:='Failed to convert';//Default response
  (*The following were my tests to see that I understood hexstr
     properly, and that I had the numbers right.
  The second value passed "clips" the first number passed to
  and upper limit. (It ROUGHLY does a MOD on it.)
  If you "clipped" any decimal number by 9, the result would
    always be 0,1,2,3... 7,8 or 9
  Clip by 99, and the result would always be 0,1,2,....97,98,99

  (MODing by 9 would give answers 0,1,2... 6,7,8.... 9 would NOT arise.)

  All of the same sort of thing "works" in the binary and hex worlds,
  but the decimal representations of the numbers necessary to "clip"
  the results to a fixed number of characters, but "use" the full range
  available from 0 to $fff... (however many f's you want to allow) are
  not easy to "see"!

  Trust me! the following work! And my code "works" the same way.

  De-rem any one of the following to see the result of those values
  *)

  //De-rem next, if using any of the following hardcoded cases....
  //laTxtResultString.caption:='Hex equivalent, sometimes with extra leading zeros: $';

  //ssTmp:= hexstr(15,$f);//Result:                 f
  //ssTmp:= hexstr(16,$f);//Result:                10
  //ssTmp:= hexstr(1048575,$fffff);//Result:    fffff
  //ssTmp:= hexstr(1048575+1,$fffff);//Result: 100000

  //De-rem next to convert what user has put on form, using hexstr
  //(This was used for building the app.)
  ssTmp:= hexstr(strtoint(ssToConvert),bMaxHexChars);//Result: Depends on
     //what user has put in form. Interactive version
     // using hexstr


  (*De-rem the next to see the results of a hexstr conversion.
    N.B.... you will need to rem OUT all of the rest of the
    the subroutine's code, and after you do, what you get
    from clicking "convert" will ignore what is in the edit
    box. The conversion values will be hard-coded.*)

  //Not sure why this was needed when using hexstr... wasn't
  //  always needed... but for some values, I got lots
  //  of leading zeros.

  (*First "cut down" the number you've been given to convert
      so that the resulting answer is no longer than you said
      you wanted it to be... but do it in a way that "uses" the
      original number as fully as possible.
    This cutting down can be done various ways... "MOD" comes
      to mind... but be careful... a "simple" mod may not be
      the full answer...

    If we are allowing h characters of hex, we need to cut
      the number to be converted back to n. The table below
      shows n using DECIMAL notation. (The lowest number for
      n will always be zero... of course.)

      h n
      1 7
      2 15
      3 4,095
      4 65,535
      5 1,048,575

      I.e.... with $ffff you can "say" what we would usually call 65535...
      but with only 4 characters, we can't, in hex, represent a bigger number.
      Not in a simple way.

      ===== START of Digression!  -----------------
      Notice that with only  5 hex characters we can represent
      a number that would take 7 characters to represent in decimal.

      ---
      If you took this further, you could achieve even greater degrees of
      compression.

      https://www.rapidtables.com/convert/number/hex-to-decimal.html
      has a good converter, and also explains stuff.

      "Hex" is "base 16". you need 16 symbols to write hex numbers. We
      use
           0,1,2... 7,8,9,a,b,c,d,e,f
             but that's arbitrary.

      You could use, say, base 1, if you used...
          0123456789abcdefghjkmnpqrtvwxyz

      See what I did? I left out i,l,o and some others, because they are
      easy to confuse with other characters.

      With base 41, we could show decimal 0-40 with just one symbol!
      Two base 41 symbols would be able to show 0-1,681 (decimal)!
      Three base 41 symbols would show 0-68,921 (decimal) !!!

      Why don't we use a higher number base?

      When you learn basic arithemetic, if your teachers are sensible,
        you only learn up to (and including) 9+9 and 9x9. After that,
        you can get the answers better ways. There are 100 adding facts,
        100 multiplying facts.

      If we used binary there would only be four facts to learn for each!...
        but even small numbers would take a lot of characters.
        (16 decimal is 10000 binary.)

      If we used base 41, there would be 1,600 facts to learn... for adding.
      And another 1,600 to learn for multiplying.

      Decimal may not be as compact as base 41, but I'll stick with it for
         most things, I think.

      BUT FOR PASSING AND STORING DATA THAT MAY INVOLVE BIG NUMBERS,
         consider base 41!!!

      (We're going to develop code for turing decimal to hex (base 16)
         ... but altering that to "do" base 41 wiuld not be hard!)


      ---- END Digression ends!   END ============== *)


  ssTmp:=copy(ssTmp,length(ssTmp)-8,9);

 result:=ssTmp;

end;//ssOLDConvertToHex

end.
