unit ldn138_u1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;

type

  { Tldn138_f1 }

  Tldn138_f1 = class(TForm)
    bQuit: TButton;
    buConvert: TButton;
    eStringOfDecimalToConvert: TEdit;
    laTxtCaution: TLabel;
    laTxtHexString: TLabel;
    laHexString: TLabel;
    laInputStringOfDecimal: TLabel;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    procedure bQuitClick(Sender: TObject);
    procedure buConvertClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    ssTmp:shortstring;
    function ssConvertToHex(ssToConvert:shortstring;
        bMaxHexChars:byte):shortstring;
  public

  end;

var
  ldn138_f1: Tldn138_f1;

const vers='08 Jun 2023, 16:10';
  //started 08 Jun 2023, for ar202 (Arduino)
  //https://wywtk.com/ardsrv/ardsrv_23518_2t2h_door.htm
  kAppName='LDN138';

(*A start!

  See LDN137... yes, sorry, LOWER number for "higher" tutorial!...
  for the second part of this.

  ---

  I've used a TRadio group just to provide an easy-to-use way
  for the user to indicate how many hex characters to allocate, i.e
  at what stage the hex result will roll over, if you give the function
  a "too big" number.

  They aren't the most intuitive component for the programmer!

  Know.... you "add buttons" saying 1,2,3... to the RadioGroup
    by adding lines with 1, 2, 3 on them to the Items property.
  I then changed the Columns property to 8,
  and the ColumnLayout property to clVerticalThenHorizontal

  To have my *3rd* button selected when the program launches, I set
    ItemIndex property to *2*
  ---
  While the program is running, I can see which radio button is
  selected with bSelected:=RadioGroup1.ItemIndex. That returns
  the INDEX of course. To get 3 into bSelected if my buttons
  are labeled 1,2,3... I need bSelected:=RadioGroup1.ItemIndex+1,
  don't I? (Not hard. Not arcane. but a great "gotcha"!)

  ---
  My use of the "Convert it" button is clumsy. Sorry. There ARE
  better ways, ways that make the conversion happen when you change
  what's in the edit box... but they are a story for another day!

  ---
  And no, in this i did NOT get to where I said I was going... my OWN
  routine for the decilal to hex conversion.

  That's in the "next" version of this.... to be found in LDN137.

*)
implementation

{$R *.lfm}

{ Tldn138_f1 }

procedure Tldn138_f1.FormCreate(Sender: TObject);
begin
  application.title:=kAppName;
  {main form.}caption:=kAppName+' vers: '+vers;
  eStringOfDecimalToConvert.text:='0000';
  RadioGroup1.caption:='How many hex characters should be used?';
  laInputStringOfDecimal.caption:='< Enter decimal to convert';
  eStringOfDecimalToConvert.text:='255';
  laHexString.caption:='';
  RadioGroup1.caption:='Hex characters to use in result:';
end;

procedure Tldn138_f1.bQuitClick(Sender: TObject);
begin
  close;//get in habit of using Close. Better than App... terminate.
  //(Important when you start using ini files updated during prgm run)
end;

procedure Tldn138_f1.buConvertClick(Sender: TObject);
begin
  ssTmp:=ssConvertToHex(eStringOfDecimalToConvert.text,RadioGroup1.ItemIndex+1);
  laHexString.caption:=ssTmp;
end;

function Tldn138_f1.ssConvertToHex(ssToConvert:shortstring;bMaxHexChars:byte):shortstring;
(*Yes! Lazarus has a function for this!...
  https://www.freepascal.org/docs-html/rtl/system/hexstr.html
  ... but I needed an ALGORITM, to "translate" to Arduino code.
  If you want hex from decimal for a Lazarus program, by all
  means use hexstr. At 8 Jun 23, the example given chose a very
  odd value for "Value" in...
  Writeln (HexStr(Value,I));
  A value of 15 ($F), or ($ffff) might have made more sense.
  *)
begin
  result:='Failed to convert';//Default response
  (*The following were my tests to see that I understood hexstr
     properly, and that I had the numbers right.
  The second value passed "clips" the first number passed to
  and upper limit. (It ROUGHLY does a MOD on it.)
  If you "clipped" any decimal number by 9, the result would
    always be 0,1,2,3... 7,8 or 9
  Clip by 99, and the result would always be 0,1,2,....97,98,99

  (MODing by 9 would give answers 0,1,2... 6,7,8.... 9 would NOT arise.)

  All of the same sort of thing "works" in the binary and hex worlds,
  but the decimal representations of the numbers necessary to "clip"
  the results to a fixed number of characters, but "use" the full range
  available from 0 to $fff... (however many f's you want to allow) are
  not easy to "see"!

  Trust me! the following work! And my code "works" the same way.

  De-rem any one of the following to see the result of those values
  *)

  //De-rem next, if using any of the following hardcoded cases....
  //laTxtHexString.caption:='Hex equivalent, sometimes with extra leading zeros: $';

  //ssTmp:= hexstr(15,$f);//Result:                 f
  //ssTmp:= hexstr(16,$f);//Result:                10
  //ssTmp:= hexstr(1048575,$fffff);//Result:    fffff
  //ssTmp:= hexstr(1048575+1,$fffff);//Result: 100000

  //De-rem next to convert what user has put on form, using hexstr
  //(This was used for building the app.)
  ssTmp:= hexstr(strtoint(ssToConvert),bMaxHexChars);//Result: Depends on
     //what user has put in form. Interactive version
     // using hexstr


  (*De-rem the next to see the results of a hexstr conversion.
    N.B.... you will need to rem OUT all of the rest of the
    the subroutine's code, and after you do, what you get
    from clicking "convert" will ignore what is in the edit
    box. The conversion values will be hard-coded.*)

  //Not sure why this was needed when using hexstr... wasn't
  //  always needed... but for some values, I got lots
  //  of leading zeros.
  ssTmp:=copy(ssTmp,length(ssTmp)-8,9);

 result:=ssTmp;

end;//ssConvertToHex
end.

